/*================================================================================

//变种丧狗


================================================================================*/

#include <amxmodx>
#include <fakemeta>
#include <engine>
#include <zombieplague>
#include <xs>
#include <hamsandwich>

// Zombie Atributes
new const zclass_name[] = { "变种丧狗" } // name
new const zclass_info[] = { "生命II 速度III 嗅觉" } // description
new const zclass_model[] = { "zombie_source" } // model
new const zclass_clawmodel[] = { "v_knife_zombie.mdl" } // claw model
const zclass_health = 2200 // health
const zclass_speed = 242 // speed
const Float:zclass_gravity = 0.85 // gravity
const Float:zclass_knockback = 1.4 // knockback

// Class IDs
new g_zclassid2

new seeall[33] = 1

new Float:g_fDelay[33]
new sprite_playerheat

new cvar_maxdistance
new cvar_updatedelay

// Zombie Classes MUST be registered on plugin_precache
public plugin_precache()
{
	register_plugin("[ZP]3d  Zombie ", "0.1", "Nic")
	sprite_playerheat = precache_model("sprites/poison.spr")
	
	// Register the new class and store ID for reference
	g_zclassid2 = zp_register_zombie_class(zclass_name, zclass_info, zclass_model, zclass_clawmodel, zclass_health, zclass_speed, zclass_gravity, zclass_knockback)	
}

// User Infected forward
public zp_user_infected_pre(id, infector)
{
	seeall[id] = 0
}

public zp_user_infected_post(id, infector)
{
	// Check if the infected player is using our custom zombie class
	if (zp_get_user_zombie_class(id) == g_zclassid2 && seeall[id] == 0)
	{
		client_print(id, print_chat, "你现在是一只变种丧狗!")
		client_PostThink(id)
	}
}

public zp_user_humanized_post(id)
{
	if(seeall[id] == 0)
		seeall[id] = 1
	
}

public fwHamPlayerSpawnPost(id) 
{
	if(seeall[id] == 0)
		seeall[id] = 1
}
public client_connect(id)
{
	seeall[id] = 1
}
public plugin_init()
{
	cvar_maxdistance = register_cvar("zp_tig_distance", 	"1000")
	cvar_updatedelay = register_cvar("zp_tig_updatedelay", "0.2")
	RegisterHam(Ham_Spawn, "player", "fwHamPlayerSpawnPost", 1)
}
public client_PostThink(id)
{
	if(!is_user_alive(id) || !(zp_get_user_zombie_class(id) == g_zclassid2 && seeall[id] == 0) || seeall[id] == 1)
		return PLUGIN_CONTINUE
	
	if((g_fDelay[id] + get_pcvar_float(cvar_updatedelay)) > get_gametime())
		return PLUGIN_CONTINUE
	
	g_fDelay[id] = get_gametime()
	
	new Float:fMyOrigin[3]
	entity_get_vector(id, EV_VEC_origin, fMyOrigin)
	
	static Players[32], iNum
	get_players(Players, iNum, "a")
	for(new i = 0; i < iNum; ++i) if(id != Players[i])
{
	new target = Players[i]
	
	if (!zp_get_user_zombie(target)) 
	{
		new Float:fTargetOrigin[3]
		entity_get_vector(target, EV_VEC_origin, fTargetOrigin)
		
		if((get_distance_f(fMyOrigin, fTargetOrigin) > get_pcvar_num(cvar_maxdistance)) 
		|| !is_in_viewcone(id, fTargetOrigin))
		continue
		
		new Float:fMiddle[3], Float:fHitPoint[3]
		xs_vec_sub(fTargetOrigin, fMyOrigin, fMiddle)
		trace_line(-1, fMyOrigin, fTargetOrigin, fHitPoint)
		
		new Float:fWallOffset[3], Float:fDistanceToWall
		fDistanceToWall = vector_distance(fMyOrigin, fHitPoint) - 10.0
		normalize(fMiddle, fWallOffset, fDistanceToWall)
		
		new Float:fSpriteOffset[3]
		xs_vec_add(fWallOffset, fMyOrigin, fSpriteOffset)
		new Float:fScale, Float:fDistanceToTarget = vector_distance(fMyOrigin, fTargetOrigin)
		if(fDistanceToWall > 100.0)
			fScale = 8.0 * (fDistanceToWall / fDistanceToTarget)
			else
				fScale = 2.0
			
			te_sprite(id, fSpriteOffset, sprite_playerheat, floatround(fScale), 125)
			
		}
	}
	return PLUGIN_CONTINUE
}

stock te_sprite(id, Float:origin[3], sprite, scale, brightness)
{
	message_begin(MSG_ONE, SVC_TEMPENTITY, _, id)
	write_byte(TE_SPRITE)
	write_coord(floatround(origin[0]))
	write_coord(floatround(origin[1]))
	write_coord(floatround(origin[2]))
	write_short(sprite)
	write_byte(scale) 
	write_byte(brightness)
	message_end()
}

stock normalize(Float:fIn[3], Float:fOut[3], Float:fMul)
{
	new Float:fLen = xs_vec_len(fIn)
	xs_vec_copy(fIn, fOut)
	
	fOut[0] /= fLen, fOut[1] /= fLen, fOut[2] /= fLen
	fOut[0] *= fMul, fOut[1] *= fMul, fOut[2] *= fMul
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ ansicpg950\\ deff0{\\ fonttbl{\\ f0\\ fnil\\ fcharset136 Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1028\\ f0\\ fs16 \n\\ par }
*/
